@component('panel.layouts.component', ['title' => 'ثبت محصول جدید'])

    @slot('style')
        <style>
            .card-header {
                text-align: center !important;
            }

            .form-control {

                background-color: hsl(315, 22%, 86%);
            }

            .required {
                color: red;
            }

            .py-5 {
                padding-top: 0 !important;
            }

            .select2 {
                width: 100% !important;
            }

            .photo {
                border: 0px;
                background-color: #fff;
            }

            .btn_photo {
                margin-bottom: -50px;
                position: relative;
            }

            /* ---------------------------------------
  /* Fine Uploader Gallery View Styles
  /* ---------------------------------------*/

            #drop-area {
                border: 2px dashed #ccc;
                border-radius: 20px;
                width: 50%;
                border-color: purple;
                padding: 10px;
            }

            #gallery {
                margin-top: 10px;
            }

            #gallery img {
                width: 150px;
                margin-bottom: 10px;
                margin-right: 10px;
                vertical-align: middle;
            }

            #progress-bar {
                display: none;
            }

            #fileElem {
                display: none;
            }

            .hide-element {
                display: none;
            }

            /* Feature Images*/


            .btn-file {
                position: relative;
                overflow: hidden;

            }

            .btn-file input[type=file] {
                position: absolute;
                top: 0;
                right: 0;
                min-width: 100%;
                min-height: 100%;
                font-size: 100px;
                text-align: right;
                filter: alpha(opacity=0);
                opacity: 0;
                outline: none;
                background: white;
                cursor: inherit;
                display: block;
            }

            .alert {
                box-shadow: 10px 10px 5px;
                -moz-box-shadow: 10px 10px 5px;
                -webkit-box-shadow: 10px 10px 5px;
            }


            .media-left {
                z-index: 1000;
                cursor: pointer;
                margin: 15px;
            }

            .thumbnail {
                color: #006dcc;
                *color: #0044cc;
            }

            .media-left img {
                cursor: pointer;
                padding-left: 20px;
                display: flex !important;

            }
#delete{
                display: flex;
                margin-left: -40px;
                position: relative;
}
            .label-tags {
                font-size: 16px;
                padding: 1%;
                color: black;
                background-color: white;
                border: 1px solid blue;
                border-radius: 4px;
                margin: 3px;
            }
            .label-tags i {
                cursor: pointer;
            }
        /*    *****************************/

        </style>
    @endslot
    @slot('subject')
        <h1><i class="fa fa-users"></i> ثبت محصول جدید </h1>
        <p>ثبت محصول جدید در فروشگاه.</p>
    @endslot
    @slot('breadcrumb')
        <li class="breadcrumb-item">محصولات</li>
    @endslot

    @slot('content')
        <div class="auth-background h-auto py-5">
            <div class="container py-5">
                <div class="row align-items-center ">
                    <div class="col-lg-12 col-md-12 mx-auto">
                        <div class="card">
                            <div class="card-header"><strong>{{ __('ثبت محصول جدید') }}</strong></div>
                            @component('product::components.message')
                            @endcomponent
                            <div class="card-body mx-lg-5 px-lg-3">
                                <form method="POST" action="{{ route('products.store') }}"
                                      enctype="multipart/form-data">
                                    @csrf

                                    <div class="form-group">
                                        <label for="title">{{ __('product.title') }}</label><i class="required">&nbsp;
                                            *</i>
                                        <input id="title" type="text"
                                               class="form-control @error('title') is-invalid @enderror" name="title"
                                               value="{{ old('title') }}" autocomplete="title" autofocus>

                                        @error('title')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror
                                    </div>
                                    <div class="form-row ">
                                        <div class="form-group col-lg-4">
                                            <label for="slug">{{ __('product.slug') }}</label>
                                            <input type="text" name="slug"
                                                   class="form-control @error('slug') is-invalid  @enderror"
                                                   value="{{old('slug')}}" autocomplete="slug" autofocus>
                                            @error('slug')
                                            <div class="alert alert-danger">{{$message}}</div>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="sku">{{ __('product.sku') }}</label>
                                            <input id="sku" type="text"
                                                   class="form-control @error('sku') is-invalid @enderror" name="sku"
                                                   autocomplete="sku" value="{{ old('sku') }}" autofocus>

                                            @error('sku')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="type">{{ __('product.type') }}</label></label><i
                                                class="required">&nbsp;
                                                *</i>
                                            <select id="type" type="text"
                                                    class="form-control @error('type') is-invalid @enderror" name="type"
                                                    value="{{ old('type') }}" autocomplete="type">
                                                <option value="">انتخاب کنید</option>
                                                <option value="0" {{ (old('type') == '0') ? 'selected' : '' }}>ساده
                                                </option>
                                                <option value="1" {{ (old('type') == '1') ? 'selected' : '' }}>متغیر
                                                </option>
                                                <option value="2" {{ (old('type') == '2') ? 'selected' : '' }}>باندل
                                                </option>

                                            </select>

                                            @error('type')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                    </div>
                                    <div class="form-row ">
                                        <div class="form-group col-lg-4">
                                            <label for="title">{{ __('product.price') }}</label><i class="required">&nbsp;
                                                *</i>
                                            <input id="input.price" type="text"
                                                   class="form-control price @error('price') is-invalid @enderror"
                                                   name="price"
                                                   value="{{ old('price') }}" autocomplete="price" autofocus>

                                            @error('price')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="sale_price">@lang('product.sale_price')</label>
                                            <input id="sale_price" type="text"
                                                   class="form-control price @error('sale_price') is-invalid @enderror"
                                                   name="sale_price"
                                                   value="{{ old('sale_price') }}" autocomplete="sale_price" autofocus>

                                            @error('sale_price')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="status">{{ __('product.status') }}</label><i class="required">&nbsp;
                                                *</i>
                                            <select id="status" type="text"
                                                    class="form-control  @error('status') is-invalid @enderror"
                                                    name="status"
                                                    autocomplete="status">
                                                <option value="">انتخاب کنید</option>
                                                <option value="1" {{ (old('status') == '1') ? 'selected' : '' }}>موجود
                                                </option>
                                                <option value="0" {{ (old('status') == '0') ? 'selected' : '' }}>
                                                    ناموجود
                                                </option>
                                            </select>
                                            @error('status')
                                            <span class="invalid-feedback" role="alert">
                                               <strong>{{ $message }}</strong>
                                            </span>
                                            @enderror
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="discription">{{ __('product.discription') }}</label></label><i
                                            class="required">&nbsp; *</i>
                                        <textarea id="discription" type="text"
                                                  class="form-control  @error('discription') is-invalid @enderror"
                                                  name="discription"

                                                  autocomplete="discription"
                                                  autofocus>{{ old('discription') }}</textarea>

                                        @error('discription')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror
                                    </div>
                                    <div class="form-group">
                                        <label for="categories">{{ __('product.categories') }}</label><i
                                            class="required">&nbsp; *</i>
                                        <select id=""
                                                class="form-control select2 @error('categories') is-invalid @enderror"
                                                name="categories[]" multiple>

                                            <option value="">انتخاب کنید</option>
                                            @foreach($categories as $cat)
                                                <option value="{{$cat->id }}">{{$cat->title}}</option>
                                            @endforeach
                                        </select>
                                        @error('categories')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror
                                    </div>
                                    <div class="form-group col-md-7">
                                        <label for="title">{{ __('product.featured_image') }}</label><i class="required">&nbsp; *</i>

                                        <span class="btn btn-primary btn-file"> <input type="file" id="uploadImages" name="featured_image" accept="image/*" class="form-control photo  browse @error('featured_image') is-invalid  @enderror"
                                            value="{{old('featured_image')}}" autocomplete="featured_image" autofocus>تصویر شاخص </span>
                                        <div class="hide-element" id="previewImages">
                                            <div class="media">
                                                <div class="media-left ">
                                                    <a href=""  role="button" class="btn btn-danger pull-right" id="delete"> <i
                                                            class="icon fa fa-close"></i></a>
                                                    <img class="media-object thumbnail m-auto" src="img/150x150.gif"
                                                         alt="" id="0" title="" data-toggle="modal"
                                                         data-target="#individualImagePreview">
                                                </div>
                                                <div class="media-body">
                                                    <p><label for="description">توضیحات: </label><input type="text" class="form-control"  value=""name="description"></p>
                                                    <p><label for="caption">عنوان: </label><input type="text" class="form-control" value="" name="caption"></p>
                                                    {{--  <p><label for="tags">Tags:max of 3 tags.comma seperated </label><input type="text" class="form-control" value="" name="tags" /></p>--}}
                                                </div>
                                            </div>
                                        </div>
                                        @error('featured_image')
                                        <span class="invalid-feedback" role="alert">
                                                 <strong>{{ $message }}</strong>
                                            </span>
                                        @enderror
                                    </div>
                                    <div class="form-group col-md-5" id="drop-area">
                                        <label for="title">{{ __('product.gallery_image') }}</label><i
                                            class="required">&nbsp; *</i>
                                        <input type="file" name="gallery_image[]" id="fileElem"
                                               class="form-control photo @error('gallery_image') is-invalid  @enderror"
                                               value="{{old('gallery_image')}}" autocomplete="gallery_image"
                                               autofocus multiple accept="image/*"
                                               onchange="handleFiles(this.files)">
                                        <label class="btn btn-primary" for="fileElem"> ساخت گالری محصولات</label>

                                        <progress id="progress-bar" max=100 value=0></progress>
                                        <div id="gallery">

                                        </div>
                                        @error('gallery_image')
                                        <span class="invalid-feedback" role="alert">
                                                    <strong>{{ $message }}</strong>
                                                </span>
                                        @enderror
                                    </div>
{{----}}

                                    <form action="" method="post" enctype="multipart/form-data">

                                    </form>

                                        <form action="/upload-target" class="dropzone">

                                            <div class="fallback">

                                                <input name="file" type="file" multiple />

                                            </div>

                                        </form>

                                        {{--                                    --}}
                                    <div class="form-group mb-0">
                                        <div class="">
                                            <button type="submit" class="btn btn-primary">
                                                {{ __('ثبت محصول') }}
                                            </button>

                                            <a href={{ route('products.index') }} type="button" class="btn btn-warning">
                                                انصراف</a>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="card-footer">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    @endslot

    @slot('script')
        <script>
            {{--Dropzone.options.dropzone =--}}
            {{--    {--}}
            {{--        maxFilesize: 12,--}}
            {{--        renameFile: function (file) {--}}
            {{--            var dt = new Date();--}}
            {{--            var time = dt.getTime();--}}
            {{--            return time + file.name;--}}
            {{--        },--}}
            {{--        acceptedFiles: ".jpeg,.jpg,.png,.gif",--}}
            {{--        addRemoveLinks: true,--}}
            {{--        timeout: 50000,--}}
            {{--        removedfile: function (file) {--}}
            {{--            var name = file.upload.filename;--}}
            {{--            $.ajax({--}}
            {{--                headers: {--}}
            {{--                    'X-CSRF-TOKEN': $('meta[name="_token"]').attr('content')--}}
            {{--                },--}}
            {{--                type: 'POST',--}}
            {{--                url: '{{ url("delete") }}',--}}
            {{--                data: {filename: name},--}}
            {{--                success: function (data) {--}}
            {{--                    console.log("File has been successfully removed!!");--}}
            {{--                },--}}
            {{--                error: function (e) {--}}
            {{--                    console.log(e);--}}
            {{--                }--}}
            {{--            });--}}
            {{--            var fileRef;--}}
            {{--            return (fileRef = file.previewElement) != null ?--}}
            {{--                fileRef.parentNode.removeChild(file.previewElement) : void 0;--}}
            {{--        },--}}

            {{--        success: function (file, response) {--}}
            {{--            console.log(response);--}}
            {{--        },--}}
            {{--        error: function (file, response) {--}}
            {{--            return false;--}}
            {{--        }--}}
            {{--    };--}}

            //             //**************************show images gallery**********************************************
            let dropArea = document.getElementById("drop-area")

            // Handle dropped files
            dropArea.addEventListener('drop', handleDrop, false)

            function preventDefaults (e) {
                e.preventDefault()
                e.stopPropagation()
            }

            function highlight(e) {
                dropArea.classList.add('highlight')
            }

            function unhighlight(e) {
                dropArea.classList.remove('active')
            }

            function handleDrop(e) {
                var dt = e.dataTransfer
                var files = dt.files

                handleFiles(files)
            }

            let uploadProgress = []
            let progressBar = document.getElementById('progress-bar')

            function initializeProgress(numFiles) {
                progressBar.value = 0
                uploadProgress = []

                for(let i = numFiles; i > 0; i--) {
                    uploadProgress.push(0)
                }
            }

            function updateProgress(fileNumber, percent) {
                uploadProgress[fileNumber] = percent
                let total = uploadProgress.reduce((tot, curr) => tot + curr, 0) / uploadProgress.length
                console.debug('update', fileNumber, percent, total)
                progressBar.value = total
            }

            function handleFiles(files) {
                files = [...files]
                initializeProgress(files.length)
                files.forEach(uploadFile)
                files.forEach(previewFile)
            }

            function previewFile(file) {
                let reader = new FileReader()
                reader.readAsDataURL(file)
                reader.onloadend = function() {
                    let img = document.createElement('img')
                    img.src = reader.result

                    document.getElementById('gallery').appendChild(img)


                }
                let close = new FileReader()
                close.readAsDataURL(file)
                close.onloadend = function() {
                    let button = document.createElement('img')
                    button.src = close.result

                    document.getElementById('gallery').appendChild(img)

                }
            }

            function uploadFile(file, i) {
                var url = 'https://api.cloudinary.com/v1_1/joezimim007/image/upload'
                var xhr = new XMLHttpRequest()
                var formData = new FormData()
                xhr.open('POST', url, true)
                xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest')

                // Update progress (can be used to show progress indicator)
                xhr.upload.addEventListener("progress", function(e) {
                    updateProgress(i, (e.loaded * 100.0 / e.total) || 100)
                })

                xhr.addEventListener('readystatechange', function(e) {
                    if (xhr.readyState == 4 && xhr.status == 200) {
                        updateProgress(i, 100) // <- Add this
                    }
                    else if (xhr.readyState == 4 && xhr.status != 200) {
                        // Error. Inform the user
                    }
                })

                formData.append('upload_preset', 'ujpu6gyk')
                formData.append('file', file)
                xhr.send(formData)
            }
        //***************FEATURE IMAGES***************************************
            $(document).ready(function () {
                $('[data-toggle="tooltip"]').tooltip({
                    html: true
                });
                $('.media').addClass('hide-element');
                $('#imagesUploadForm').submit(function (evt) {
                    evt.preventDefault();
                });
                $('#edit').click(function () {
                    console.log('click detected inside circl-o of edit');
                    $('#edit').toggleClass('fa-circle-o').toggleClass('fa-check-circle');
                    if ($('#edit').hasClass('fa-check-circle')) {
                        $('#captionForImage').toggleClass('hide-element');
                    } else {
                        $('#captionForImage').toggleClass('hide-element');
                    }
                });
                $('#delete').click(function () {
                    console.log('click detected inside circl-o of delete');
                    $(this).closest('#previewImages').find('.media').remove();
                    $('#delete').toggleClass('fa-circle-o').toggleClass('fa-times-circle');
                });
                //namespace variable to determine whether to continue or not
                var proceed = false;
                //Ensure that FILE API is supported by the browser to proceed
                if (window.File && window.FileReader && window.FileList && window.Blob) {
                    if (window.webkitURL || window.URL) {
                        $('#errorMessaage').removeClass('hide-element').addClass(
                            '').html('');
                        proceed = true;
                    } else {
                        $('#errorMessaage').removeClass('hide-element').addClass(
                            'alert-warning').html('');
                    }

                } else {
                    $('#errorMessaage').removeClass('hide-element').addClass(
                        'alert-warning').html('');
                }
                if (proceed) {
                    var input = "";
                    var formData = new FormData();
                    $('input[name=featured_image]').on("change", function (e) {
                        var counter = 0;
                        var modalPreviewItems = "";
                        input = this.files;
                        $($(this)[0].files).each(function (i, file) {
                            formData.append("file[]", file);
                        });
                        $('#previewImages').removeClass('hide-element');
                        $('#imagesUpload').removeClass('disabled');
                        var successUpload = 0;
                        var failedUpload = 0;
                        var extraFiles = 0;
                        var size = input.length;
                        $(input).each(function () {
                            var reader = new FileReader();
                            var uploadImage = this;
                            console.log(this);
                            reader.readAsArrayBuffer(this);
                            reader.onload = function (e) {
                                var magicNumbers = validateImage.magicNumbersForExtension(e);
                                var fileSize = validateImage.isUploadedFileSizeValid(uploadImage);
                                var extension = validateImage.uploadFileExtension(uploadImage);
                                var isValidImage = validateImage.validateExtensionToMagicNumbers(magicNumbers);
                                var thumbnail = validateImage.generateThumbnail(uploadImage);
                                if (fileSize && isValidImage) {
                                    $('#' + counter).parents('.media').removeClass('hide-element');
                                    $('#' + counter).attr('src', thumbnail).height('200');
                                    $('#uploadDataInfo').removeClass('hide-element').addClass('alert-success');
                                    successUpload++;
                                    modalPreviewItems += carouselInsideModal.createItemsForSlider(thumbnail, counter);

                                } else {
                                    $('#uploadDataInfo').removeClass('hide-element alert-success').addClass('alert-warning');
                                    failedUpload++;
                                }
                                counter++;
                                if (counter === size) {
                                    $('#myCarousel').append(carouselInsideModal.createIndicators(successUpload, "myCarousel"));
                                    $('#previewItems').append(modalPreviewItems);
                                    $('#previewItems .item').first().addClass('active');
                                    $('#carouselIndicators > li').first().addClass('active');
                                    $('#myCarousel').carousel({
                                        interval: 2000,
                                        cycle: true
                                    });
                                    if (size > 4) {
                                        $('#toManyFilesUploaded').html("Only files displayed below will be uploaded");
                                        extraFiles = size - 4;
                                    }

                                    $('#filesCount').html(successUpload + " files are ready to upload");
                                    if (failedUpload !== 0 || extraFiles !== 0) {
                                        failedUpload === 0 ? "" : failedUpload;
                                        extraFiles === 0 ? "" : extraFiles;
                                        $('#filesUnsupported').html(failedUpload + extraFiles + " files were not selected for upload");
                                    }

                                }
                            };
                        });

                    });

                    var toBeDeleted = [];
                    var eachImageValues = [];
                    $('.media').each(function (index) {
                        var imagePresent = "";
                        $("body").on("click", "#delete" + index, function () {
                            imagePresent = $("#" + index).attr('src');
                            $("#undo" + index).removeClass('hide-element');
                            $("#" + index).attr('src', './img/200x200.gif');
                            $("#delete" + index).addClass('hide-element');
                            toBeDeleted.push(index);

                        });
                        $("body").on("click", "#undo" + index, function () {
                            $("#" + index).attr('src', imagePresent);
                            $("#undo" + index).addClass('hide-element');
                            $("#delete" + index).removeClass('hide-element');
                            var indexToDelete = toBeDeleted.indexOf(index);
                            if (indexToDelete > -1) {
                                toBeDeleted.splice(indexToDelete, 1);
                                // console.log(toBeDeleted);
                                $("#delete" + index).parent().find('input[type="text"]').prop('disabled', false).removeClass('disabled');
                            }
                            if (toBeDeleted.length === 4) {
                                $('#sendImagesToServer').prop('disabled', true).html('No Files to Upload');

                            } else {
                                $('#sendImagesToServer').prop('disabled', false).html('Update &amp; Preview');
                            }
                        });
                    });





                    var validateImage = {
                        magicNumbersForExtension: function (event) {
                            var headerArray = (new Uint8Array(event.target.result)).subarray(0, 4);
                            var magicNumber = "";
                            for (var counter = 0; counter < headerArray.length; counter++) {
                                magicNumber += headerArray[counter].toString(16);
                            }
                            return magicNumber;
                        },
                        isUploadedFileSizeValid: function (fileUploaded) {
                            var fileSize = fileUploaded.size;
                            var maximumSize = 2097125;
                            var isValid = "";
                            if (fileSize <= maximumSize) {
                                isValid = true;
                            } else {
                                isValid = false;
                            }
                            return isValid;
                        },
                        uploadFileExtension: function (fileUploaded) {
                            var fileExtension = "";
                            var imageType = "";
                            imageType = fileUploaded.type.toLowerCase();
                            fileExtension = imageType.substr((imageType.lastIndexOf('/') + 1));
                            return fileExtension;
                        },
                        validateExtensionToMagicNumbers: function (magicNumbers) {
                            var properExtension = "";
                            if (magicNumbers.toLowerCase() === "ffd8ffe0" || magicNumbers.toLowerCase() === "ffd8ffe1" ||
                                magicNumbers.toLowerCase() === "ffd8ffe8" ||
                                magicNumbers.toLocaleLowerCase() === "89504e47") {
                                properExtension = true;

                            } else {
                                properExtension = false;
                            }
                            return properExtension;
                        },
                        generateThumbnail: function (uploadImage) {
                            if (window.URL)
                                imageSrc = window.URL.createObjectURL(uploadImage);
                            else
                                imageSrc = window.webkitURL.createObjectURL(uploadImage);
                            return imageSrc;
                        }
                    };
                    var carouselInsideModal = {
                        createIndicators: function (carouselLength, dataTarget) {
                            var carouselIndicators = '<ol class = "carousel-indicators" id="carouselIndicators">';
                            for (var counter = 0; counter < carouselLength; counter++) {
                                carouselIndicators += '<li data-target = "#' + dataTarget + '"data-slide-to="' + counter + '"></li>';
                            }
                            carouselIndicators += "</ol>";
                            return carouselIndicators;
                        },
                        createItemsForSlider: function (imgSrc, counter) {
                            var item = '<div class = "item">' + '<img src="' + imgSrc + '" id="preview' + counter + '" /></div>';
                            return item;
                        }
                    };
                }
            });

        //    *******************************
function multiUploader(formId, inputId, btnStartId, btnStopId){
    this.noFiles = true;
    this.FilesToUp = {};
    this.btnStart = document.getElementById(btnStartId);
    this.btnStop = document.getElementById(btnStopId);
    this.control = document.getElementById(inputId);
    this.filesTable = document.getElementById(formId);
    this.videoWidth = '50px';
    this.pictureWidth = '50px';


}

multiUploader.prototype.constructor = function(){
    this.filesTable.style.display = "none";
    var $self = this;
    this.control.addEventListener("change",
        function(event) {
            if ($self.noFiles) {
                $self.filesTable.style.display = "table";
                $self.btnStart.addEventListener("click", function() {
                    $self.uploadFiles();
                });
            }
            $self.noFiles = false;

            for (var i = 0; i < $self.control.files.length; i++) {
                var idFile = Math.round(+new Date() / 1000) + i;
                $self.FilesToUp[idFile] =  $self.control.files[i];

                var tr = document.createElement("tr"),
                    tdImg = document.createElement("td"),
                    tdInput = document.createElement("td"),
                    tdSize = document.createElement("td"),
                    tdDel = document.createElement("td"),
                    deleteBtn = document.createElement("button"),
                    input = document.createElement("input");

                tr.setAttribute("class", "trFile");
                if ($self.FilesToUp[idFile].type.match("image.*")) {
                    var linkThumb = document.createElement("a");
                    var img = document.createElement("img");
                    linkThumb.innerHTML = "Voir la miniature";
                    linkThumb.setAttribute("data-idFile", idFile);
                    linkThumb.addEventListener("click", function(){
                        $self.getThumb(this);
                    });
                    tdImg.appendChild(linkThumb);
                    img.setAttribute("id", idFile);
                    img.style.display = "none";
                    tdImg.appendChild(img);
                } else if($self.FilesToUp[idFile].type.match("video.*")){
                    var linkThumb = document.createElement("a");
                    var video = document.createElement("video");
                    var source = document.createElement("source");
                    linkThumb.innerHTML = "Voir la miniature";
                    linkThumb.setAttribute("data-idFile", idFile);
                    linkThumb.addEventListener("click", function(){
                        $self.getThumb(this);
                    });
                    tdImg.appendChild(linkThumb);

                    video.style.width = this.videoWidth;
                    video.setAttribute("controls", "controls");
                    video.setAttribute("type", $self.FilesToUp[idFile].type);
                    source.setAttribute("id", idFile);
                    source.src = window.URL.createObjectURL($self.FilesToUp[idFile]);
                    video.style.display = "none";
                    video.appendChild(source);
                    tdImg.appendChild(video);
                } else {
                    tdImg.innerHTML = $self.FilesToUp[idFile].type;
                }
                tdImg.setAttribute("class", "ImgThumb");
                tr.appendChild(tdImg);
                input.value = $self.FilesToUp[idFile].name.replace("." + $self.fileExtension($self.FilesToUp[idFile].name), "");
                input.name = idFile;
                input.type="text";
                input.setAttribute("class", "input-medium");
                tdInput.appendChild(input);
                tdInput.setAttribute("class", "tdInput");
                tr.appendChild(tdInput);
                tdSize.innerHTML = $self.bytesToSize($self.FilesToUp[idFile].size);
                tdSize.setAttribute("class", "tdSize");
                tr.appendChild(tdSize);
                deleteBtn.innerHTML = "X";
                deleteBtn.setAttribute("data-idFile", idFile);
                deleteBtn.setAttribute("class", "btn");
                deleteBtn.addEventListener("click", function(){
                    $self.delFile(this);
                });
                tdDel.setAttribute("class", "tdDel");
                tdDel.appendChild(deleteBtn);
                tr.appendChild(tdDel);
                $self.filesTable.firstChild.appendChild(tr);
            }
        }, false
    );
}
multiUploader.prototype.fileExtension = function(filename) {
    return filename.substr((~-filename.lastIndexOf(".") >>> 0) + 2);
}

multiUploader.prototype.bytesToSize = function(bytes) {
    var sizes = [ "Octets", "Ko", "Mo", "Go", "To" ];
    if (bytes == 0)
        return "n/a";
    var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
    var currentSize = bytes / Math.pow(1024, i);
    return currentSize.toFixed(2) + " " + sizes[i];
}

multiUploader.prototype.getThumb = function(element){
    var idFile = element.getAttribute("data-idFile");
    var img = document.getElementById(idFile);
    if(img.style.display == "none"){
        element.innerHTML = "Cacher la miniature";
        if(img.src == "")
            img.src = window.URL.createObjectURL(this.FilesToUp[idFile]);
        if(img.parentNode.tagName == "video"){
            img.parentNode.style.display = "block";
        }
        img.style.display = "block";
    }else{
        element.innerHTML = "Voir la miniature";
        if(img.parentNode.tagName == "video"){
            img.parentNode.style.display = "none";
        }
        img.style.display = "none";
    }
}

multiUploader.prototype.delFile = function(element){
    var idFile = element.getAttribute("data-idFile");
    delete(this.FilesToUp[idFile]);
    var parent = element.parentNode.parentNode;
    parent.parentNode.removeChild(parent);

}

multiUploader.prototype.uploadFiles = function(){
    var $self = this;
    for(var idFile in this.FilesToUp){break;}
    if(idFile == undefined){ return true;}
    var trLine = this.filesTable.querySelectorAll(".trFile")[0];
    var form = new FormData();
    form.append(idFile, this.FilesToUp[idFile]);
    form.append(idFile, document.getElementsByName(idFile)[0].value);
    trLine.querySelectorAll(".tdInput")[0].firstElementChild.disabled = true;
    trLine.querySelectorAll(".tdDel")[0].firstElementChild.disabled = true;
    var xhr = new XMLHttpRequest();
    var endTime = 0;
    var startTime = (new Date()).getTime();
    xhr.upload.onprogress = function(e) {
        var duration = ((new Date()).getTime() - startTime) / 1000;
        var speedBps = (e.loaded / duration);

        trLine.querySelectorAll(".tdSize")[0].innerHTML = $self.bytesToSize(e.loaded) + ' / ' + $self.bytesToSize(e.total) + "<br />";
        document.getElementById("speed").innerHTML = $self.bytesToSize(speedBps) + "/s";
        trLine.querySelectorAll(".tdInput")[0].style.backgroundSize = Math.ceil((e.loaded / e.total) * 100) + "% 100%";
        if(e.loaded === e.total){
            trLine.querySelectorAll(".tdSize")[0].innerHTML = "Traitement en cours";
        }
    };
    xhr.onload = function() {
        if (xhr.readyState === 4 && xhr.status === 200){
            delete($self.FilesToUp[idFile]);

            trLine.parentNode.removeChild(trLine);
            delete(trLine);
            $self.uploadFiles();
        }
        if(xhr.status !== 200){
            trLine.querySelectorAll(".tdSize")[0].innerHTML = xhr.status + " " + xhr.statusText;
        }
    }
    xhr.open("post", "/", true);
    xhr.send(form);
    this.btnStop.onclick = function(){
        xhr.abort();
        trLine.querySelectorAll(".tdInput")[0].style.backgroundSize = "0% 100%";
        trLine.querySelectorAll(".tdInput")[0].firstElementChild.disabled = false;
        trLine.querySelectorAll(".tdDel")[0].firstElementChild.disabled = false;
        trLine.querySelectorAll(".tdSize")[0].innerHTML = $self.bytesToSize($self.FilesToUp[idFile].size);
    }
    return false;
}
var uploader = null;
window.onload = function() {
    uploader = new multiUploader("filesTable", "fileUpload", "upload", "stop");
    uploader.constructor();
};
        </script>
    @endslot

@endcomponent

